SystemOrganization addCategory: #'ObjectDiff-OD'!
SystemOrganization addCategory: #'ObjectDiff-OD-Test'!
SystemOrganization addCategory: #'ObjectDiff-Sheet'!
SystemOrganization addCategory: #'ObjectDiff-Sheet-Test'!
SystemOrganization addCategory: #'ObjectDiff-Sheet-GUI'!
SystemOrganization addCategory: #'ObjectDiff-System'!
SystemOrganization addCategory: #ObjectDiff!
SystemOrganization addCategory: #'ObjectDiff-Test'!

!Set methodsFor: '*ObjectDiff-System' stamp: 'HwaJong 10/27/2012 23:10'!
objectDiffKeys
^self isEmpty
	ifTrue: [Array new]
	ifFalse: [1 to: self size]! !

!Set methodsFor: '*ObjectDiff-System' stamp: 'HwaJong 10/28/2012 00:32'!
objectDiffValueAt: anInteger 
^self asArray at: anInteger ! !

!Dictionary methodsFor: '*ObjectDiff-System' stamp: 'HwaJong 10/27/2012 23:08'!
objectDiffKeys
^self keys! !

!Dictionary methodsFor: '*ObjectDiff-System' stamp: 'HwaJong 10/28/2012 00:22'!
objectDiffValueAt: anObject
^self at: anObject! !

!Array methodsFor: '*ObjectDiff' stamp: 'HwaJong 10/28/2012 14:15'!
literalForm
^self collect: #literalForm! !

TestCase subclass: #KeySheetTest
	instanceVariableNames: 's'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Test'!

!KeySheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 10:12'!
setUp
super setUp.
s := KeySheet new.! !

!KeySheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 11:46'!
testEqual
s leftSideObject: 2@3.
s rightSideObject: 2@3.
self assert: s comparisonResultInLiterals equals: #equal.
self deny: (s canOpenInnerDifference).
self deny: (s canOpenInnerDifferenceAtKey: 'x').
self deny: (s canOpenInnerDifferenceAtKey: 'y').! !

!KeySheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 11:55'!
testIdentical
s leftSideObject: 37.
s rightSideObject: 37.
self assert: s comparisonResultInLiterals equals: #identical.
self deny: (s canOpenInnerDifference).
self deny: (s canOpenInnerDifferenceAtKey: 'foo').
! !

!KeySheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 11:26'!
testLeftMissing
s leftSideObject: 'hell'.
s rightSideObject: 'hello'.
self assert: s comparisonResultInLiterals equals: #(#(#class #same) #(1 #identical) #(2 #identical) #(3 #identical) #(4 #identical) #(5 #leftMissing)) ! !

!KeySheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 14:38'!
testObject
| indi |
s leftSideObject: (2@3 corner: 10@15).
s rightSideObject: (2@3 corner: 20@15).
self assert: s comparisonResultInLiterals equals: #(#(#class #same) #('origin' #equal) #('corner' #different)).
self assert: (s canOpenInnerDifference).
self deny: (s canOpenInnerDifferenceAtKey: 'origin').
self assert: (s canOpenInnerDifferenceAtKey: 'corner').
indi := (s openInnerDifferenceAtKey: 'corner').
self assert: indi comparisonResultInLiterals equals: #(#(#class #same) #('x' #different) #('y' #identical))! !

!KeySheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 11:26'!
testRightMissing
s leftSideObject: 'hello'.
s rightSideObject: 'hell'.
self assert: s comparisonResultInLiterals equals: #(#(#class #same) #(1 #identical) #(2 #identical) #(3 #identical) #(4 #identical) #(5 #rightMissing)) ! !

!KeySheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 11:26'!
testString
s leftSideObject: 'hell'.
s rightSideObject: 'llll'.
self assert: s comparisonResultInLiterals equals: #(#(#class #same) #(1 #different) #(2 #different) #(3 #identical) #(4 #identical)) ! !

TestCase subclass: #ODSheetTest
	instanceVariableNames: 'sheet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Sheet-Test'!

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:34'!
setUp
super setUp.
sheet := ODSheet new.
sheet objects: {'hello'. 19. World}.
sheet accesses: {[:o| o sizeInMemory]. [:o| o className]. [:o| o even]}.
! !

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:35'!
testValueAt1At1
self assert: (sheet valueOfObjectAt: 1 byAccessAt: 1) equals: 9! !

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:31'!
testValueAt1At2
self assert: (sheet valueOfObjectAt: 1 byAccessAt: 2) equals: 'ByteString'! !

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:29'!
testValueAt1At3
self assert: ((sheet valueOfObjectAt: 1 byAccessAt: 3) isKindOf: MessageNotUnderstood).! !

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:35'!
testValueAt2At1
self assert: (sheet valueOfObjectAt: 2 byAccessAt: 1) equals: 0! !

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:36'!
testValueAt2At2
self assert: (sheet valueOfObjectAt: 2 byAccessAt: 2) equals: 'SmallInteger'! !

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:39'!
testValueAt2At3
self deny: (sheet valueOfObjectAt: 2 byAccessAt: 3).! !

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:36'!
testValueAt3At1
self assert: (sheet valueOfObjectAt: 3 byAccessAt: 1) equals: 52! !

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:37'!
testValueAt3At2
self assert: (sheet valueOfObjectAt: 3 byAccessAt: 2) equals: 'PasteUpMorph'! !

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:39'!
testValueAt3At3
self assert: ((sheet valueOfObjectAt: 3 byAccessAt: 3) isKindOf: MessageNotUnderstood).! !

TestCase subclass: #ODiffyArrayArrayTest
	instanceVariableNames: 'array1 array2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-OD-Test'!

!ODiffyArrayArrayTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 11:08'!
setUp
|o|
super setUp.
o := 1@2.
array1 := Array with: 1 with: 3 with: 3/4 with: (o extent: 7@8).
array2 := Array with: 3 with: 3 with: 3/4 with: (o extent: 7@7).! !

!ODiffyArrayArrayTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 11:15'!
testArray
|d e|
d := OArrayDiffy new.
d leftSideObject: array1.
d rightSideObject: array2.
e := d elementDiffies.
self assert: e size equals: 4.
(e at: 1) ifIdentical: [self fail] ifEqual: [self fail]  ifDifferent: [].
(e at: 2) ifIdentical: [] ifEqual: [self fail]  ifDifferent: [self fail].
(e at: 3) ifIdentical: [self fail] ifEqual: []  ifDifferent: [self fail].
(e at: 4) ifIdentical: [self fail] ifEqual: [self fail]  ifDifferent: [].! !

!ODiffyArrayArrayTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:15'!
testArrayAt4
|d e r|
d := OArrayDiffy new.
d leftSideObject: array1.
d rightSideObject: array2.
e := d elementDiffies.
r := (e at: 4) diffies.
self assert: r size equals: 2.
self assert: ((r at: 1) instVarName) equals: 'origin'.
(r at: 1) ifIdentical: [] ifEqual: [self fail]  ifDifferent: [self fail].
self assert: ((r at: 2) instVarName) equals: 'corner'.
(r at: 2) ifIdentical: [self fail] ifEqual: [self fail]  ifDifferent: [].
! !

TestCase subclass: #ODiffyIVarTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-OD-Test'!

!ODiffyIVarTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 10:38'!
test2Rects
|d o r1 r2 i |
o := 1@2.
r1 := o extent: 3@4.
r2 := o extent: 3@3.
d:=ODiffy new.
d leftSideObject: r1.
d rightSideObject: r2.
i := d ivarDiffies.
self assert: i size equals: 2.
self assert: 'origin' equals: (i at: 1) instVarName.
self assert: 'corner' equals: (i at: 2) instVarName.

(i at: 1) ifIdentical: [] ifEqual: [self fail] ifDifferent: [self fail].
(i at: 2) ifIdentical: [self fail] ifEqual: [self fail] ifDifferent: [].! !

!ODiffyIVarTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 11:03'!
test2RectsAgain
|d o r1 r2 i |
o := 1@2.
r1 := o extent: 3@4.
r2 := o extent: 3@3.
d:=ODiffy new.
d leftSideObject: r1.
d rightSideObject: r2.
i := (d ivarDiffies at: 2) ivarDiffies.
self assert: i size equals: 2.
self assert: 'x' equals: (i at: 1) instVarName.
(i at: 1) ifIdentical: [] ifEqual: [self fail] ifDifferent: [self fail].
self assert: 'y' equals: (i at: 2) instVarName.
(i at: 2) ifIdentical: [self fail] ifEqual: [self fail] ifDifferent: [].
! !

TestCase subclass: #ODiffyObjectObjectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-OD-Test'!

!ODiffyObjectObjectTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 10:25'!
testDifferent

	|d|
	d := ODiffy new.
	d leftSideObject: (3@4 extent: 1@2).
	d rightSideObject: (1@2 extent: 10@5).
	d ifIdentical: [self fail] ifEqual: [self fail] ifDifferent: [].! !

!ODiffyObjectObjectTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 10:24'!
testEqual

	|d|
	d := ODiffy new.
	d leftSideObject: (1@2 extent: 3@4).
	d rightSideObject: (1@2 extent: 3@4).
	d ifIdentical: [self fail] ifEqual: [] ifDifferent: [self fail].! !

!ODiffyObjectObjectTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 10:26'!
testIdentical

	|d r|
	r := 1@2 extent: 3@4.
	d := ODiffy new.
	d leftSideObject: r.
	d rightSideObject: r.
	d ifIdentical: [] ifEqual: [self fail] ifDifferent: [self fail].! !

TestCase subclass: #ODiffyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-OD-Test'!

!ODiffyTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 10:20'!
testDifferent

	|d|
	d := ODiffy new.
	d leftSideObject: 3.
	d rightSideObject: 4.
	d ifIdentical: [self fail] ifEqual: [self fail] ifDifferent: [].! !

!ODiffyTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 10:21'!
testEqual

	|d|
	d := ODiffy new.
	d leftSideObject: 3/4.
	d rightSideObject: 3/4.
	d ifIdentical: [self fail] ifEqual: [] ifDifferent: [self fail].! !

!ODiffyTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 10:19'!
testIdentical

	|d|
	d := ODiffy new.
	d leftSideObject: 3.
	d rightSideObject: 3.
	d ifIdentical: [] ifEqual: [self fail] ifDifferent: [self fail].! !

TestCase subclass: #OIvarReferenceTest
	instanceVariableNames: 'rectangle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-OD-Test'!

!OIvarReferenceTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 10:48'!
setUp
super setUp.
rectangle := 1@2 corner: 10@20.! !

!OIvarReferenceTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 10:54'!
testCorner

self assert: ((OIvarReference object: rectangle instVarName: 'corner')
			value)
	equals: rectangle corner.! !

!OIvarReferenceTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 10:52'!
testOrigin

self assert: ((OIvarReference object: rectangle instVarName: 'origin')
			value)
	equals: rectangle origin.! !

TestCase subclass: #ObjectDiffSystemTest
	instanceVariableNames: 'object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-System'!

ObjectDiffSystemTest subclass: #ODSArrayTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-System'!

!ODSArrayTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:17'!
setUp
super setUp.
object := #(10 20 30 40).! !

!ODSArrayTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:06'!
testObjectDiffKeys
self assert: object objectDiffKeys equals: (1 to: 4)! !

!ODSArrayTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:19'!
testObjectDiffValueAt1
self assert: (object objectDiffValueAt: 1) equals: (10)! !

!ODSArrayTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:19'!
testObjectDiffValueAt2
self assert: (object objectDiffValueAt: 2) equals: (20)! !

!ODSArrayTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:19'!
testObjectDiffValueAt3
self assert: (object objectDiffValueAt: 3) equals: (30)! !

!ODSArrayTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:19'!
testObjectDiffValueAt4
self assert: (object objectDiffValueAt: 4) equals: (40)! !

ObjectDiffSystemTest subclass: #ODSDictionaryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-System'!

!ODSDictionaryTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:06'!
setUp
super setUp.
object := Dictionary new.
object at: 'hello' put: 'kitty'.
object at: 30 put: 'thirty'.
! !

!ODSDictionaryTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:07'!
testObjectDiffKeys
self assert: object objectDiffKeys equals: {30. 'hello'}! !

!ODSDictionaryTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:22'!
testObjectDiffValueAt30
self assert: (object objectDiffValueAt: 30) equals: ('thirty')! !

!ODSDictionaryTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:21'!
testObjectDiffValueAtHello
self assert: (object objectDiffValueAt: 'hello') equals: ('kitty')! !

ObjectDiffSystemTest subclass: #ODSObjectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-System'!

!ODSObjectTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:07'!
setUp
super setUp.
object := (2@3) corner: (10@15).! !

!ODSObjectTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:08'!
testObjectDiffKeys
self assert: object objectDiffKeys equals: {'origin'. 'corner'}! !

!ODSObjectTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:27'!
testObjectDiffValueAtCorner
self assert: (object objectDiffValueAt: 'corner') equals: (10@15)! !

!ODSObjectTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:23'!
testObjectDiffValueAtOrigin
self assert: (object objectDiffValueAt: 'origin') equals: (2@3)! !

ObjectDiffSystemTest subclass: #ODSSetTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-System'!

!ODSSetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:09'!
setUp
super setUp.
object := Set new.
object add: 10.
object add: 'joy'.
! !

!ODSSetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:09'!
testObjectDiffKeys 
self assert: object objectDiffKeys equals: (1 to: 2)! !

!ODSSetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:30'!
testObjectDiffValueAt1
self assert: ({10. 'joy'} includes: (object objectDiffValueAt: 1))! !

!ODSSetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:33'!
testObjectDiffValueAt2
self assert: ({10. 'joy'} includes: (object objectDiffValueAt: 2))! !

!ODSSetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:34'!
testObjectDiffValueAtDiffers
self deny: ((object objectDiffValueAt: 1) = (object objectDiffValueAt: 2))! !

!SequenceableCollection methodsFor: '*ObjectDiff-System' stamp: 'HwaJong 10/27/2012 22:21'!
objectDiffKeys
^self isEmpty
	ifTrue: [Array new]
	ifFalse: [1 to: self size]! !

!SequenceableCollection methodsFor: '*ObjectDiff-System' stamp: 'HwaJong 10/28/2012 00:18'!
objectDiffValueAt: anInteger 
^self at: anInteger! !

Object subclass: #KSClassComparison
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

KSClassComparison subclass: #KSDifferentClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

!KSDifferentClass methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 12:32'!
literalForm
^{#class. #different}! !

KSClassComparison subclass: #KSSameClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

!KSSameClass methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 10:29'!
literalForm
^{#class. #same}! !

Object subclass: #KSComparison
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

KSComparison subclass: #KSDifferenceInDetail
	instanceVariableNames: 'classComparison insideComparisons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

!KSDifferenceInDetail classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 14:01'!
leftSideObject: object1 rightSideObject: object2 commonKeys: anArray 
^self new
	classComparison: (object1 class = object2 class ifTrue: [KSSameClass new] ifFalse: [KSDifferentClass new]);
	insideComparisons: (anArray collect: [:key| (KSInsideComparison leftSideObject: object1 rightSideObject: object2 key: key)])
! !

!KSDifferenceInDetail methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 12:14'!
canOpenInnerDifference
^insideComparisons anySatisfy: [:each| each canOpenInnerDifference ] ! !

!KSDifferenceInDetail methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 12:34'!
canOpenInnerDifferenceAtKey: aByteString 
^(insideComparisons detect: [:each| each key = aByteString]) canOpenInnerDifference! !

!KSDifferenceInDetail methodsFor: 'accessing' stamp: 'HwaJong 10/28/2012 12:00'!
classComparison: anObject
 classComparison := anObject
! !

!KSDifferenceInDetail methodsFor: 'accessing' stamp: 'HwaJong 10/28/2012 12:00'!
insideComparisons: anArray 
insideComparisons := anArray ! !

!KSDifferenceInDetail methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 12:13'!
literalForm
^Array streamContents: [:stream| stream nextPut: classComparison literalForm; nextPutAll: insideComparisons literalForm]! !

KSComparison subclass: #KSEqual
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

!KSEqual methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 11:46'!
canOpenInnerDifference
^false! !

!KSEqual methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 11:45'!
canOpenInnerDifferenceAtKey: anObject 
^false! !

!KSEqual methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 10:23'!
literalForm
^#equal! !

KSComparison subclass: #KSIdentical
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

!KSIdentical methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 11:55'!
canOpenInnerDifference
^false! !

!KSIdentical methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 11:55'!
canOpenInnerDifferenceAtKey: anObject 
^false! !

!KSIdentical methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 10:20'!
literalForm
^#identical! !

Object subclass: #KSInsideComparison
	instanceVariableNames: 'leftSideObject rightSideObject key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

!KSInsideComparison classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 12:19'!
leftSideObject: object1 rightSideObject: object2 key: key 
|properClass|
properClass := (object1 objectDiffHasKey: key) ifTrue: [ (object2 objectDiffHasKey: key) ifTrue: [|partLeft partRight| partLeft := object1 objectDiffValueAt: key. partRight := object2 objectDiffValueAt: key.(partLeft==partRight ifTrue: [KSPartIdentical ] ifFalse: [partLeft=partRight ifTrue: [KSPartEqual ] ifFalse: [KSPartDifferent ]])] ifFalse: [KSRightPartMissing ]] ifFalse: [KSLeftPartMissing ].

^properClass new
	leftSideObject: object1;
	rightSideObject: object2;
	key: key! !

!KSInsideComparison methodsFor: 'accessing' stamp: 'HwaJong 10/28/2012 13:34'!
key

	^ key! !

!KSInsideComparison methodsFor: 'accessing' stamp: 'HwaJong 10/28/2012 14:27'!
key: anObject 
key := anObject ! !

!KSInsideComparison methodsFor: 'accessing' stamp: 'HwaJong 10/28/2012 13:33'!
leftSideObject: anObject 
leftSideObject := anObject ! !

!KSInsideComparison methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 14:19'!
literalForm
^{key. self insideComparisonLiteral}! !

!KSInsideComparison methodsFor: 'accessing' stamp: 'HwaJong 10/28/2012 13:33'!
rightSideObject: anObject 
rightSideObject := anObject ! !

KSInsideComparison subclass: #KSLeftPartMissing
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

!KSLeftPartMissing methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 14:19'!
insideComparisonLiteral
^#leftMissing! !

KSInsideComparison subclass: #KSPartDifferent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

!KSPartDifferent methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 12:28'!
canOpenInnerDifference
^true! !

!KSPartDifferent methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 14:20'!
insideComparisonLiteral
^#different! !

KSInsideComparison subclass: #KSPartEqual
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

!KSPartEqual methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 12:27'!
canOpenInnerDifference
^false! !

!KSPartEqual methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 14:21'!
insideComparisonLiteral
^#equal! !

KSInsideComparison subclass: #KSPartIdentical
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

!KSPartIdentical methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 14:21'!
insideComparisonLiteral
^#identical! !

KSInsideComparison subclass: #KSRightPartMissing
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

!KSRightPartMissing methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 14:22'!
insideComparisonLiteral
^#rightMissing! !

Object subclass: #KeySheet
	instanceVariableNames: 'leftSideObject rightSideObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

!KeySheet methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 11:46'!
canOpenInnerDifference
^self comparisonResult canOpenInnerDifference! !

!KeySheet methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 11:45'!
canOpenInnerDifferenceAtKey: anObject
^self comparisonResult canOpenInnerDifferenceAtKey: anObject
! !

!KeySheet methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 01:46'!
commonKeys
|keySet|
keySet := Set new.
keySet addAll: leftSideObject objectDiffKeys.
keySet addAll: rightSideObject objectDiffKeys.
^keySet asArray! !

!KeySheet methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 14:00'!
comparisonResult
leftSideObject == rightSideObject ifTrue: [^KSIdentical new].
leftSideObject = rightSideObject ifTrue: [^KSEqual new].
^KSDifferenceInDetail leftSideObject: leftSideObject rightSideObject:  rightSideObject commonKeys: self commonKeys.
	! !

!KeySheet methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 11:37'!
comparisonResultInLiterals
^self comparisonResult literalForm
	! !

!KeySheet methodsFor: 'accessing' stamp: 'HwaJong 10/28/2012 01:44'!
leftSideObject: anObject
leftSideObject := anObject! !

!KeySheet methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 14:38'!
openInnerDifferenceAtKey: anObject 
^self class new
	leftSideObject: (leftSideObject objectDiffValueAt: anObject);
	rightSideObject: (rightSideObject objectDiffValueAt: anObject)! !

!KeySheet methodsFor: 'accessing' stamp: 'HwaJong 10/28/2012 01:45'!
rightSideObject: anObject 
rightSideObject := anObject! !

Object subclass: #OArrayDiffy
	instanceVariableNames: 'leftSideObject rightSideObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-OD'!

!OArrayDiffy methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 11:14'!
elementDiffies
^(1 to: leftSideObject size)
	collect: 
		[:key|
		ODiffy new
			leftSideObject: (leftSideObject at: key);
			rightSideObject: (rightSideObject at: key)
		]! !

!OArrayDiffy methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 11:10'!
leftSideObject: anObject 
leftSideObject:= anObject ! !

!OArrayDiffy methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 11:10'!
rightSideObject: anObject 

rightSideObject:= anObject! !

Object subclass: #ODAccess
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Sheet'!

Object subclass: #ODSheet
	instanceVariableNames: 'objects accesses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Sheet'!

!ODSheet methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 14:19'!
accesses
	^ accesses! !

!ODSheet methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 14:19'!
accesses: anArray
	accesses := anArray
! !

!ODSheet methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 14:19'!
objects
	^ objects! !

!ODSheet methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 14:19'!
objects: anArray
	objects := anArray
! !

!ODSheet methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:25'!
valueOfObjectAt: objectIndex byAccessAt: accessIndex
|object access|
object := objects at: objectIndex.
access := accesses at: accessIndex.
^[access value: object] on: Error do: [:ex| ex]
! !

Object subclass: #ODWorkspace
	instanceVariableNames: 'sheet cellExtent contents win'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Sheet-GUI'!

!ODWorkspace methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 18:19'!
cellMorphAtRow: rowIndex atColumn: colIndex
|cellObject morph|
cellObject := 
rowIndex = 0
	ifTrue: 
		[colIndex = 0
			ifTrue: ['objects'] 
			ifFalse: [sheet accesses at: colIndex]]
	ifFalse: 
		[colIndex = 0
			ifTrue: [sheet objects at: rowIndex]
			ifFalse: [sheet valueOfObjectAt: rowIndex byAccessAt: colIndex]].
morph := cellObject printString asMorph.
morph extent: cellExtent.
^morph! !

!ODWorkspace methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 18:53'!
construct

self makeSheet.

cellExtent := 200@40.

contents := 
UITheme builder newColumn: 
	(Array streamContents: 
		[:rowStream|	
		0 to: sheet objects size do: 
			[:objectIndex|
			rowStream nextPut: 
				(UITheme builder newRow: 
					(Array streamContents: 
						[:stream|
						0 to: sheet accesses size do: 
							[:accessIndex|
							stream nextPut: (self cellMorphAtRow: objectIndex  atColumn: accessIndex)
							]
						])).
			]
]).! !

!ODWorkspace methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 15:24'!
makeSheet
sheet := ODSheet new.
sheet objects: {'hello'. 19. World}.
sheet accesses: {[:o| o sizeInMemory]. [:o| o className]. [:o| o even]}.
! !

Object subclass: #ODiffy
	instanceVariableNames: 'leftSideObject rightSideObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-OD'!

!ODiffy methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:12'!
diffies
^self ivarDiffies! !

!ODiffy methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 09:56'!
ifIdentical: iBlock ifEqual: eBlock ifDifferent: dBlock
^leftSideObject == rightSideObject
	ifTrue: iBlock
	ifFalse: 
		[leftSideObject = rightSideObject
			ifTrue: eBlock
			ifFalse: dBlock]! !

!ODiffy methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 10:57'!
instVarName
	(leftSideObject respondsTo: #instVarName) ifFalse: [self error: ''].
	(rightSideObject respondsTo: #instVarName) ifFalse: [self error: ''].
	(leftSideObject instVarName = rightSideObject instVarName) ifFalse: [self error: ''].
	^leftSideObject instVarName! !

!ODiffy methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 10:33'!
ivarDiffies
^leftSideObject class instVarNames
	collect: 
		[:iName|
			OIVarDiffy new
				leftSideObject: leftSideObject;
				rightSideObject: rightSideObject;
				instVarName: iName]! !

!ODiffy methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 10:59'!
ivarDiffies100
^leftSideObject class instVarNames
	collect: 
		[:iName|
			ODiffy new
				leftSideObject: (OIvarReference object: leftSideObject instVarName: iName);
				rightSideObject: (OIvarReference object: rightSideObject instVarName: iName)]! !

!ODiffy methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 09:55'!
leftSideObject
	^ leftSideObject! !

!ODiffy methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 09:55'!
leftSideObject: anObject
	leftSideObject := anObject! !

!ODiffy methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 09:55'!
rightSideObject
	^ rightSideObject! !

!ODiffy methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 09:55'!
rightSideObject: anObject
	rightSideObject := anObject! !

Object subclass: #OIVarDiffy
	instanceVariableNames: 'instVarName leftSideObject rightSideObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-OD'!

!OIVarDiffy methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 11:01'!
ifIdentical: iBlock ifEqual: eBlock ifDifferent: dBlock
|i1 i2|
i1 := self leftSideValue.
i2 := self rightSideValue.
^i1 == i2
	ifTrue: iBlock
	ifFalse: 
		[i1 = i2
			ifTrue: eBlock
			ifFalse: dBlock]! !

!OIVarDiffy methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 10:36'!
instVarName
	^ instVarName! !

!OIVarDiffy methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 10:35'!
instVarName: aString 
	instVarName := aString! !

!OIVarDiffy methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 11:02'!
ivarDiffies
^(self leftSideValue) class instVarNames
	collect: 
		[:iName|
			OIVarDiffy new
				leftSideObject: (self leftSideValue);
				rightSideObject: (self rightSideValue);
				instVarName: iName]! !

!OIVarDiffy methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 10:34'!
leftSideObject: anObject 
	leftSideObject := anObject! !

!OIVarDiffy methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 11:00'!
leftSideValue.
^leftSideObject instVarAt: (leftSideObject class instVarNames indexOf: instVarName)! !

!OIVarDiffy methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 10:35'!
rightSideObject: anObject 
	rightSideObject := anObject! !

!OIVarDiffy methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 11:01'!
rightSideValue.
^rightSideObject instVarAt: (rightSideObject class instVarNames indexOf: instVarName)! !

Object subclass: #OIvarReference
	instanceVariableNames: 'object instVarName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-OD'!

!OIvarReference classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 10:53'!
object: anObject instVarName: aString 

^self new
	object: anObject;
	instVarName: aString;
	yourself! !

!OIvarReference methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 10:47'!
instVarName
	^ instVarName! !

!OIvarReference methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 10:47'!
instVarName: aString
	instVarName := aString
! !

!OIvarReference methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 10:47'!
object
	^ object! !

!OIvarReference methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 10:47'!
object: anObject
	object := anObject! !

!OIvarReference methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 10:50'!
value

	^object instVarAt: (object class instVarNames indexOf: instVarName)! !

!Object methodsFor: '*ObjectDiff' stamp: 'HwaJong 10/3/2012 10:48'!
diff: anObject 
|obj1 obj2 pr|
obj1 := self.
obj2 := anObject.

pr:= [:obj| obj className, String cr, (obj longPrintStringLimitedTo: 20000)].
(DiffMorph new from: (pr value:obj1) to: (pr value:obj2)) openInWindowLabeled: obj1 printString, ' vs ', obj2 printString.
! !

!Object methodsFor: '*ObjectDiff-System' stamp: 'HwaJong 10/28/2012 02:29'!
objectDiffHasKey: anObject
^self objectDiffKeys includes: anObject ! !

!Object methodsFor: '*ObjectDiff-System' stamp: 'HwaJong 10/27/2012 22:18'!
objectDiffKeys
^self class instVarNames.! !

!Object methodsFor: '*ObjectDiff-System' stamp: 'HwaJong 10/28/2012 00:25'!
objectDiffValueAt: aString 
^self instVarAt: (self class instVarNames indexOf: aString)! !
